# Parameter rendering

The `renderParameters` and `doNotRenderParameters` can be used to specify which configuration parameters should be rendered when doing experiments within a step.

Parameter rendering can be defined at the step level for baseline, preset, and optimize steps. This is not possible for bootstrap steps as bootstrapped experiments are not executed.

| Field                   | Type             | Value restrictions                                                                                                                                             | Is required | Description                                                                                                                                                                                             |
| ----------------------- | ---------------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `renderParameters`      | Array of strings | <p>should contain strings in the form <em>component.parameter</em> or <em>component.</em></p><p><em>component.</em> means every parameter of the component</p> | No          | Which configuration parameters should be rendered or applied when doing experiments/trials in addition to ones in the parameters selection or in the *values* if the step is of type baseline or preset |
| `doNotRenderParameters` | Array of strings | <p>should contain strings in the form <em>component.parameter</em> or <em>component.</em></p><p><em>component.</em> means every parameter of the component</p> | No          | Which configuration parameters should not be rendered or applied when doing experiments/trials                                                                                                          |

### Examples

The following baseline step specifies that every parameter of the component 'os' should not be rendered while the parameter 'cpu\_limit' of the component 'docker' should be rendered:

{% code lineNumbers="true" %}

```yaml
name: "mybaseline"
type: "baseline"
values: # every parameter in 'values' is rendered by default
  jvm.jvm_compilation_threads: 10
  jvm.jvm_gcType: -XX:+UseG1GC
doNotRenderParameters: ["os.*"] # every parameter of the component 'os' will not be rendered
renderParameters: ["docker.cpu_limit"] # the parameter 'cpu_limit' of the component 'docker' will be rendered
```

{% endcode %}

The following preset step specifies that the parameter 'cpu\_limit' of the component 'docker' should be rendered:

{% code lineNumbers="true" %}

```yaml
name: "mypreset"
type: "preset"
values:
  jvm.jvm_compilation_threads: 10
  jvm.jvm_gcType: -XX:+UseG1GC
renderParameters: ["docker.cpu_limit"] # the parameter 'cpu_limit' of the component 'docker' will be rendered
```

{% endcode %}

The following optimize step specifies that every parameter of the component 'os' should not be rendered:

{% code lineNumbers="true" %}

```yaml
name: "myoptimize"
type: "optimize"
numberOfExperiment: 200
doNotRenderParameters: ["os.*"] # every parameter of the component 'os' will not be rendered
```

{% endcode %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.akamas.io/akamas-docs/3.2.1-1/akamas-reference/construct-templates/study-template/parameter-rendering.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
